#!/bin/bash

# add here M-functions which you like to add for running

LIST="M02"


RES_COL=30
MOVE_TO_COL="echo -en \\033[${RES_COL}G"
SETCOLOR_SUCCESS="echo -en \\033[1;32m"
SETCOLOR_FAILURE="echo -en \\033[1;31m"
SETCOLOR_WARNING="echo -en \\033[1;33m"
SETCOLOR_NORMAL="echo -en \\033[0;39m"

success() {
  $MOVE_TO_COL
  echo -n "[  "
  $SETCOLOR_SUCCESS
  echo -n $"OK"
  $SETCOLOR_NORMAL
  echo -n "  ]"
  echo -ne "\n"
};

failure() {
  $MOVE_TO_COL
  echo -n "["
  $SETCOLOR_FAILURE
  echo -n $"FAILED"
  $SETCOLOR_NORMAL
  echo -n "]"
  echo -ne "\n"
};



make_bytecode()
{

# echo NAME: src/"$iname"

if [ -f src/"$iname".plc ] ; then


awk -f ../../../bin/include/include.awk src/${iname}.plc | \
awk -f ../../../bin/include/define.awk >temp.plc

#../../../plc/bin/iPLC temp.plc -v -o bytecode/${oname}
../../../bin/iPLC temp.plc -v -o bytecode/${oname}
#rm temp.plc



if [ -f src/"$iname".xml ] ; then
cp -a src/${iname}.xml	../plc.data/${oname}.xml
fi

#cp -a src/${iname} 	~/work/lkplasma3/pdata/plc/src/
#cp -a src/${iname}.xml 	~/work/lkplasma3/pdata/plc/src/



success

else

failure

fi

}


echo

rm bytecode/*

#iname=autogas-hpr260.plc 	oname=C07 	make_bytecode


for i in ${LIST} ; do  

iname=$i
oname=${i::3}

echo -n Name: "$i" "      "


make_bytecode

done 


#rm temp.plc
#rm temp.plc.bytecode

../../../bin/genromfs -a 64 -d bytecode -V PLC_`date +%Y-%m-%d_%H%M` -f ../plc.data/eeprom.rom



