#ifndef _____COMMON_CONST_MYCNC__
#define _____COMMON_CONST_MYCNC__



//Common defines for myPLC

#define PLC_FILENAME_NOT_FOUND	501

#define PLCCMD_MOTION_CONTINUE	1001
#define PLCCMD_MOTION_SKIP      1002
#define PLCCMD_MOTION_SOFT_SKIP 1003
#define PLCCMD_MOTION_PAUSE     1004
#define PLCCMD_PLC_PAUSE        1005
#define PLCCMD_PLC_FORK_PAUSE   1006
#define PLCCMD_LINE_SOFT_STOP   1007
#define PLCCMD_LINE_STOP        1008


#define PLCCMD_REPLY_TO_MYCNC   1100

#define PLCCMD_SET_CNC_VAR      1010
#define PLCCMD_SET_THC_VAR      1011
#define PLCCMD_SET_DEVICE_VAR16 1012
#define PLCCMD_SET_DEVICE_VAR32 1014

#define PLCCMD_SET_CNC_EXTVAR   1020

#define PLCCMD_MOTION_ABORT     1032
#define PLCCMD_MOTION_BREAK     1033

#define PLCCMD_SAVE_POS         1040

#define PLCCMD_THC_START        1050
#define PLCCMD_THC_STOP         1051
#define PLCCMD_THC_PAUSE        1052
#define PLCCMD_THC_CONTINUE     1053

#define PLCCMD_WATCHBIT1_ON     1060
#define PLCCMD_WATCHBIT2_ON     1061
#define PLCCMD_WATCHBIT3_ON     1062
#define PLCCMD_WATCHBIT4_ON     1063

#define PLCCMD_TRIGGER1_ON     1060
#define PLCCMD_TRIGGER2_ON     1061
#define PLCCMD_TRIGGER3_ON     1062
#define PLCCMD_TRIGGER4_ON     1063



#define PLCCMD_TRIGGER1_OFF	1064
#define PLCCMD_TRIGGER2_OFF	1065
#define PLCCMD_TRIGGER3_OFF	1066
#define PLCCMD_TRIGGER4_OFF	1067

#define PLCCMD_WATCHBIT1_OFF	1064
#define PLCCMD_WATCHBIT2_OFF	1065
#define PLCCMD_WATCHBIT3_OFF	1066
#define PLCCMD_WATCHBIT4_OFF	1067

#define PLCCMD_WATCHBIT5_ON     1068
#define PLCCMD_WATCHBIT6_ON     1069
#define PLCCMD_WATCHBIT7_ON     1070
#define PLCCMD_WATCHBIT8_ON     1071

#define PLCCMD_WATCHBIT5_OFF	1072
#define PLCCMD_WATCHBIT6_OFF	1073
#define PLCCMD_WATCHBIT7_OFF	1074
#define PLCCMD_WATCHBIT8_OFF	1075

#define PLCCMD_WAIT_FOR_CAMERA	1090
#define PLCCMD_WAIT_VARSET      1091
#define PLCCMD_WAIT_VARCLEAR    1092
#define PLCCMD_CAMERA_START     1093
#define PLCCMD_CAMERA_FINISH    1094


#define PLCCMD_PLC_DEBUG        1098
#define PLCCMD_PLC_RESTART      1099


#define PLC_BROADCAST_INQUIRY0      1200
#define PLC_BROADCAST_INQUIRY1      1201
#define PLC_BROADCAST_INQUIRY2      1202
#define PLC_BROADCAST_INQUIRY3      1203
#define PLC_BROADCAST_INQUIRY4      1204
#define PLC_BROADCAST_INQUIRY5      1205
#define PLC_BROADCAST_INQUIRY6      1206
#define PLC_BROADCAST_INQUIRY7      1207
#define PLC_BROADCAST_INQUIRY8      1208
#define PLC_BROADCAST_INQUIRY9      1209
#define PLC_BROADCAST_INQUIRY10     1210
#define PLC_BROADCAST_INQUIRY11     1211
#define PLC_BROADCAST_INQUIRY12     1212
#define PLC_BROADCAST_INQUIRY13     1213
#define PLC_BROADCAST_INQUIRY14     1214
#define PLC_BROADCAST_INQUIRY15     1215


#define PLC_BROADCAST_OK            1220
#define PLC_BROADCAST_ABORTED       1221

#define PLCCMD_MODBUS_SPINDLE_SPEED	1230
#define PLCCMD_MODBUS_SPINDLE_CMD	1231

#define PLCCMD_SET_PIDTIME	1240


#define plc_proc_check_plasma   10

#define plc_proc_venting        11
#define plc_proc_start_power    12

#define plc_proc_cooling        14
#define plc_proc_plasma         15
#define plc_proc_wait_plasma    18
#define plc_proc_pierce         27
#define plc_proc_no_plasma	62

#define plc_proc_check_preflow  16
#define plc_proc_check_cutflow  17

#define plc_proc_check_gases    23
#define plc_proc_test_out       24

#define proc_m_function		30
#define proc_zeroing		32

#define plc_proc_probing	33

#define plc_proc_ignition	50
#define plc_proc_preheat	51
#define plc_proc_soft_start	52
#define plc_proc_piercing	53

#define plc_proc_flame		54

#define plc_proc_cutting	60
#define plc_proc_purge		61
#define plc_proc_no_cutting	62

#define plc_proc_moveup		65

#define plc_proc_spindle	70


#define plc_proc_idle		0



//exit codes
#define plc_process		0
// no exit (process)
#define plc_exit_gas_fail	2
// no air pressure sensor
#define plc_exit_plasma_timeout	3
// wait plasma timeout
#define plc_exit_plasma_fail	4
// plasma sensor fail during cutting
#define plc_exit_alarm_key	5
// alarm key pressed
#define plc_exit_coolant_fail	6
// no coolang flow sensor
#define plc_exit_probe_error	7
// no signal from probe sensor
#define plc_exit_motor_shorted	8
#define plc_exit_broadcast_error	10


#define plc_exit_normal		99
// normal exit
#define plc_exit_extern_break	100
// external break

//messages


#define PLC_MESSAGE_PLASMA_OK               101
#define PLC_MESSAGE_WATCHBIT_ACTION         110

#define PLC_MESSAGE_SPINDLE_SPEED_CHANGED   120
#define PLC_MESSAGE_PULL_OUT_TOOL           130
#define PLC_MESSAGE_SPINDLE_TURNING         131

#define PLC_MESSAGE_ENCODER_DATA            140
#define PLC_MESSAGE_GVAR_VALUE              141
#define PLC_MESSAGE_UID                     142
#define PLC_MESSAGE_HCONTROL_OFFSET         144
#define PLC_MESSAGE_TANGENT_ANGLE           145
#define PLC_MESSAGE_USER                    146
#define PLC_MESSAGE_HCONTROL_JSPEED         147
#define PLC_MESSAGE_HCONTROL_DC             148

#define PLC_MESSAGE_ASK_RECALC              150

#define PLC_MESSAGE_SOFTLIMIT_STOP          151

#define PLC_MESSAGE_GVARSET                 153


#define PLC_MESSAGE_IHC_NOT_CONNECTED       155
#define PLC_MESSAGE_IHC_ERROR               156

#define PLC_MESSAGE_LATHE_GEARS             160

#define PLC_MESSAGE_COUNTDOWN16             165


#define PLC_MESSAGE_ERR_VM              -1
#define PLC_MESSAGE_ERR_ROMFS           -2

#define PLC_MESSAGE_MOTION_BUFFER_EMPTY -5

#define PLC_MESSAGE_ERR_SENSOR_COOLANT	-10
#define PLC_MESSAGE_ERR_SENSOR_AIR      -11
#define PLC_MESSAGE_ERR_SENSOR_GAS      -12
#define PLC_MESSAGE_ERR_SENSOR_OXYGEN	-13
#define PLC_MESSAGE_ERR_SENSOR_PLASMA	-14
#define PLC_MESSAGE_ERR_PROBING         -15

#define PLC_MESSAGE_ERR_PLASMA_FAIL     -20
#define PLC_MESSAGE_ERR_PLASMA_TIMEOUT	-21

#define PLC_MESSAGE_PRESSED_ALARM_KEY	-30
#define PLC_MESSAGE_PRESSED_STOP_KEY	-31

#define PLC_MESSAGE_MOTOR_SHORTED	-35

#define MAPPED_OUT_THC_LOWSPEED          63
#define MAPPED_OUT_LOW_MOTOR_CURRRENT    65


#define THC_STATUS_NOT_CONFIGURED	0
#define THC_STATUS_ENABLE	1   //2
#define THC_STATUS_PAUSE	2   //4
#define THC_STATUS_THC_ON	3   //8
#define THC_STATUS_IHC_ON	4   //16
#define THC_STATUS_JOG_POS	5
#define THC_STATUS_JOG_NEG	6
#define THC_STATUS_MOVE_POS	7
#define THC_STATUS_MOVE_NEG	8
#define THC_STATUS_LOW_SPEED	9
#define THC_STATUS_JUMP_ON	10
#define THC_STATUS_DELAYED	11


#define THC_VAR_CONFIGURE	0
#define THC_VAR_ENABLE		1
#define THC_VAR_PAUSE		2
#define THC_VAR_THC_ON		3
#define THC_VAR_IHC_ON		4
#define THC_VAR_SPEED_JOG	5
#define THC_VAR_JOG         6
#define THC_VAR_ARC_VOLTAGE_REF	7
#define THC_VAR_DAC         8
#define THC_VAR_DELAY_ON_THC	9
#define THC_VAR_LIFT_TYPE	10
#define THC_VAR_LOW_SPEED	11

#define THC_VAR_PID_KP		16
#define THC_VAR_PID_KP_NEG	17
#define THC_VAR_PID_KI		18
#define THC_VAR_PID_KI_NEG	19
#define THC_VAR_PID_K0		20
#define THC_VAR_PID_KCTL	21
#define THC_VAR_PID_CTL_MAX	22
#define THC_VAR_PID_CTL_MIN	23
#define THC_VAR_DEBUG		24

#define THC_VAR_JUMP_VALUE	25
#define THC_VAR_JUMP_DURATION   26
#define THC_VAR_JUMP_SPEED      27
#define THC_VAR_JUMP_BACK       28
#define THC_VAR_DO_JUMP         29


#define CNC_GVAR_PWM_WITH_PID	16


#define DBG_MYCNC_HW0       'H'
#define DBG_MYCNC_THC       'T'
#define DBG_MYTHC_CTL		'+'

#define DBG_MYHEAD_HW1      'h'


#define DBG_MYSLAVE_MSG     '$'

#define CMD_ROM_WRITE		'>'
#define CMD_SET_VARIABLES	'v'
#define CMD_SET_VARIABLES_X	'{'
#define CMD_GET_VARIABLES	'G'

#define MSG_TOOL_LENGTH		'l'
#define MSG_PROBING         'p'
#define MSG_G10_L2_APPLY	'2'
#define MSG_GVAR_APPLY		'A'
#define MSG_G10_L80_APPLY	'a'
#define MSG_G10_L70_APPLY	'7'
#define MSG_G10_LXXX_APPLY	'G'
#define MSG_G10_L81_APPLY	'1'
#define MSG_BUILD_INFO		'i'
#define MSG_ODOMETER		'o'
#define MSG_SLAVE_VARIABLE  'd'
#define MSG_SCANDATA        'S'
#define MSG_THC_ARC_VOLTAGE 'T'
#define MSG_THC_DC_DATA     'D'
#define MSG_ENC_POSITION    ':'
#define MSG_HT_REPLY        'h'


#define MSG_G289_INQUIRY    '9'
#define MSG_PLC_MOVE_INQUIRY 'v'

#define MSG_RTCP_DATA0      'r'
#define MSG_ROMFS_CRC       'R'
#define MSG_UDP_PACKET_LOST '-'
#define MSG_MPID_TUNING_K   'K'
#define MSG_ET5_SCOPEDATA   's'
#define MSG_ET5_ERROR       '5'

#define MSG_TIMERS_DATA     't'

#define MSG_THC_SCOPEDATA   '<'

#define MSG_MODBUS_EXCEPTION 'B'
#define MSG_MODBUS_IN_DEBUG '3'
#define MSG_MODBUS_OUT_DEBUG '4'

#define MSG_ET7_KEYS        'k'



#define PLCEVENT_MOTION		0
#define PLCEVENT_LOW_SPEED	1
#define PLCEVENT_WATCH_BIT	2
#define PLCEVENT_LUBRICANT	3
#define PLCEVENT_EMERGENCY_STOP	4
#define MAX_PLCEVENTS           16


#define io_proc_idle          0xff




#endif // __COMMON_CONST_MYCNC__
